#ifndef GLWIDGET_H
#define GLWIDGET_H

#include <QGLWidget>
#include <QMouseEvent>
#include <QTimer>
#include "rubics.h"

class MyGLWidget: public QGLWidget
{
    Q_OBJECT;

     int xRot;
     int yRot;
     int zRot;

    Cubik rubik;

    QPoint lastPos;
    QTimer *timer;

    void setXRotation(int angle);
    void setYRotation(int angle);
    void setZRotation(int angle);

public:
    MyGLWidget(QWidget *parent=0);
    ~MyGLWidget();
    void SaveToFile(QString fn);
    void LoadFromFile(QString fn);
protected:
    void initializeGL();
    void resizeGL(int width, int height);
    void paintGL();

    void mousePressEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
public slots:
    void layerup();
    void layerdn();
    void fwaxis();
    void sdaxis();
    void upaxis();
    void startrotation();
    void randcubik();
private slots:
    void nextframe();
};
#endif // GLWIDGET_H
