#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QFileDialog>
#include <QMessageBox>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    GLW = new MyGLWidget();
    ui->verticalLayout->addWidget(GLW);

    connect(ui->NextLayerButton,SIGNAL(clicked()),GLW,SLOT(layerup()));
    connect(ui->PreviousLayerButton,SIGNAL(clicked()),GLW,SLOT(layerdn()));
    connect(ui->SelectFDAxisButton,SIGNAL(clicked()),GLW,SLOT(fwaxis()));
    connect(ui->SelectSDAxisButton,SIGNAL(clicked()),GLW,SLOT(sdaxis()));
    connect(ui->SelectUPAxisButton,SIGNAL(clicked()),GLW,SLOT(upaxis()));
    connect(ui->RotateButton,SIGNAL(clicked()),GLW,SLOT(startrotation()));
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_actionSave_Image_activated()
{
        QString filename = QFileDialog::getOpenFileName(this,tr("Save Image"), "/home/bunyk", tr("Image Files (*.png *.jpg *.bmp)"));
    QPixmap pixmap = GLW->renderPixmap(0,0,false);

    if(!pixmap.save(filename,0,-1))
    {
        QMessageBox::critical(this,"Error","Cannot save image to file: \""+filename+"\"");
    }
}

void MainWindow::on_actionAbout_Qt_activated()
{
    QMessageBox::aboutQt(this,"About Qt");
}

void MainWindow::on_actionAuthor_activated()
{
    QMessageBox::about(this,"About author","Bunyk Taras. <br />Visit my site at <a href=\"http://bunyk.wordpress.com/\">www.bunyk.wordpress.com</a>");
}

void MainWindow::on_actionAbout_activated()
{
    QMessageBox::about(this,"About","<h1>Rubics Cube</h1>Model of Rubics cube using OpenGL and QT");
}

void MainWindow::on_actionNew_activated()
{
    GLW->randcubik();
}

void MainWindow::on_actionSave_activated()
{
    QString filename = QFileDialog::getOpenFileName(this,tr("Save cubik"), "/home/bunyk", tr("Rubik Files (*.rub)"));
    GLW->SaveToFile(filename);
}

void MainWindow::on_actionLoad_activated()
{
    QString filename = QFileDialog::getOpenFileName(this,tr("Load cubik"), "/home/bunyk", tr("Rubik Files (*.rub)"));
    GLW->LoadFromFile(filename);
}
