#include "rubics.h"
#include <QGLWidget>
#include <stdlib.h>

#include <QCoreApplication>
#include <QDateTime>
#include <iostream>

#include <iostream>
#include <ctime>

using namespace std;

int random()
{ //std::srand(std::time(nullptr)); // use current time as seed for random generator
  int ran = std::rand();
 return ran;
}

#define NOR glNormal3d // I want write less
#define VER glVertex3d

void COL(int num) // set color of face, 0 - color of nonselected chamfer, 7 - color of selected chamfer
{
    const float colors[8][3]={{0.1,0.1,0.1}, {1,1,0},{1,0,0},{0,1,0},{0,0,1},{1,0,1},{0,1,1},{0.9,0.9,0.9}};
    glColor3f(colors[num][0],colors[num][1],colors[num][2]);
}

    Cubel::Cubel()
    {
        chamfers=true; // all initial settings
        faces=true;
        space=0.9;
        chamfer=0.2;
        a=1-chamfer;
        selected=0;
        top=1;
        bottom=2;
        left=3;
        right=4;
        front=5;
        back=6;
    }
    void Cubel::reset() // return colors of faces to initial state
    {
        top=1;
        bottom=2;
        left=3;
        right=4;
        front=5;
        back=6;
    }

    ///////// Rotation of faces
    void Cubel::rotateup() //conterclockwise
    {
        int tmp=front;front=left;left=back;back=right;right=tmp;
    }
    void Cubel::rotatefd()
    {
        int tmp=left;left=top;top=right;right=bottom;bottom=tmp;
    }
    void Cubel::rotatesd()
    {
        int tmp=front;front=top;top=back;back=bottom;bottom=tmp;
    }
    void Cubel::rotateupcw() //clockwise
    {
        int tmp=right;right=back;back=left;left=front;front=tmp;
    }
    void Cubel::rotatefdcw()
    {
        int tmp=bottom;bottom=right;right=top;top=left;left=tmp;
    }
    void Cubel::rotatesdcw()
    {
        int tmp=bottom;bottom=back;back=top;top=front;front=tmp;
    }

    void Cubel::draw() // drawing
    {
        glPushMatrix(); // we will scale our cube, so must save model matrix
        glScaled(space,space,space); // just for fun we make space between cubels
        if(chamfers) // draw chamfers
        {
        if(selected) COL(7); // set color
            else COL(0);
        glBegin(GL_TRIANGLES); // draw corner triangles
            NOR(1,1,-1);
            VER(a,a,-1);
            VER(1,a,-a);
            VER(a,1,-a);

            NOR(1,1,1);
            VER(a,a,1);
            VER(1,a,a);
            VER(a,1,a);

            NOR(-1,1,-1);
            VER(-a,a,-1);
            VER(-1,a,-a);
            VER(-a,1,-a);

            NOR(1,-1,-1);
            VER(a,-a,-1);
            VER(1,-a,-a);
            VER(a,-1,-a);
            ///
            NOR(-1,-1,1);
            VER(-a,-a,1);
            VER(-1,-a,a);
            VER(-a,-1,a);

            NOR(1,-1,1);
            VER(a,-a,1);
            VER(1,-a,a);
            VER(a,-1,a);

            NOR(-1,1,1);
            VER(-a,a,1);
            VER(-1,a,a);
            VER(-a,1,a);

            NOR(-1,-1,-1);
            VER(-a,-a,-1);
            VER(-1,-a,-a);
            VER(-a,-1,-a);
        glEnd();
        }
        glBegin(GL_QUADS);
        if(chamfers)
        {
        // chamfer ring 1
            NOR(1,0,-1);
            VER(a,a,-1);
            VER(a,-a,-1);
            VER(1,-a,-a);
            VER(1,a,-a);

            NOR(1,0,1);
            VER(a,a,1);
            VER(a,-a,1);
            VER(1,-a,a);
            VER(1,a,a);

            NOR(-1,0,-1);
            VER(-a,a,-1);
            VER(-a,-a,-1);
            VER(-1,-a,-a);
            VER(-1,a,-a);

            NOR(-1,0,1);
            VER(-a,a,1);
            VER(-a,-a,1);
            VER(-1,-a,a);
            VER(-1,a,a);

        // chamfer ring 2
            NOR(0,1,-1);
            VER(a,a,-1);
            VER(-a,a,-1);
            VER(-a,1,-a);
            VER(a,1,-a);

            NOR(0,1,1);
            VER(a,a,1);
            VER(-a,a,1);
            VER(-a,1,a);
            VER(a,1,a);

            NOR(0,-1,-1);
            VER(a,-a,-1);
            VER(-a,-a,-1);
            VER(-a,-1,-a);
            VER(a,-1,-a);

            NOR(0,-1,1);
            VER(a,-a,1);
            VER(-a,-a,1);
            VER(-a,-1,a);
            VER(a,-1,a);

        // chamfer ring 3
            NOR(-1,1,0);
            VER(-1,a,a);
            VER(-1,a,-a);
            VER(-a,1,-a);
            VER(-a,1,a);

            NOR(1,1,0);
            VER(1,a,a);
            VER(1,a,-a);
            VER(a,1,-a);
            VER(a,1,a);

            NOR(-1,-1,0);
            VER(-1,-a,a);
            VER(-1,-a,-a);
            VER(-a,-1,-a);
            VER(-a,-1,a);

            NOR(1,-1,0);
            VER(1,-a,a);
            VER(1,-a,-a);
            VER(a,-1,-a);
            VER(a,-1,a);
        }
////////////////////////////// faces
            if(faces)
            {
            COL(front);
            NOR(0,0,-1); // front
            VER(a,a,-1);
            VER(a,-a,-1);
            VER(-a,-a,-1);
            VER(-a,a,-1);

            COL(back);
            NOR(0,0,1); // back
            VER(a,a,1);
            VER(a,-a,1);
            VER(-a,-a,1);
            VER(-a,a,1);

            COL(right);
            NOR(1,0,0); //right
            VER(1,a,a);
            VER(1,a,-a);
            VER(1,-a,-a);
            VER(1,-a,a);

            COL(left);
            NOR(-1,0,0); //left
            VER(-1,a,a);
            VER(-1,a,-a);
            VER(-1,-a,-a);
            VER(-1,-a,a);

            COL(top);
            NOR(0,1,0); //up
            VER(-a,1,-a);
            VER(a,1,-a);
            VER(a,1,a);
            VER(-a,1,a);

            COL(bottom);
            NOR(0,-1,0); //down
            VER(-a,-1,-a);
            VER(a,-1,-a);
            VER(a,-1,a);
            VER(-a,-1,a);
            }
        glEnd();
        glPopMatrix(); // restore all changes of position

    }

QString Cubel::tostring()
{
    QString res;
    if(selected) res="+";
    else res="-";
    res+=QString::number(top);
    res+=QString::number(bottom);
    res+=QString::number(left);
    res+=QString::number(right);
    res+=QString::number(front);
    res+=QString::number(back);
    return res;
}

void Cubel::fromstring(QString s)
{
    selected=s[0]=='+';
    top=s[1].digitValue();
    bottom=s[2].digitValue();
    left=s[3].digitValue();
    right=s[4].digitValue();
    front=s[5].digitValue();
    back=s[6].digitValue();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    void Cubik::reselectbody() // when we change axis or layer cubels must change colors of chamfers
    {
        int i,j,k;
        if(selectax==SD)
        {
            for(i=0;i<3;i++)
            for(j=0;j<3;j++)
            for(k=0;k<3;k++)
                body[i][j][k].selected=(i==selecth);
        }else
        if(selectax==UP)
        {
            for(i=0;i<3;i++)
            for(j=0;j<3;j++)
            for(k=0;k<3;k++)
                body[i][j][k].selected=(j==selecth);
        }else
        if(selectax==FD)
        {
            for(i=0;i<3;i++)
            for(j=0;j<3;j++)
            for(k=0;k<3;k++)
                body[i][j][k].selected=(k==selecth);
        };

    }
    void Cubik::drawuplayer(int h) // we must have funtions for drawing one selected layer normal to every axis
    {
        int i,j;
        glPushMatrix();
        glTranslated(-2,(h-1)*2,-2);

        for(i=0;i<3;i++)
        {
            for(j=0;j<3;j++)
            {
                body[j][h][i].draw();
                glTranslated(2,0,0);
            }
            glTranslated(-6,0,2);
        }
        glPopMatrix();
    }
    void Cubik::drawsdlayer(int h)
    {
        int i,j;
        glPushMatrix();
        glTranslated((h-1)*2,-2,-2);

        for(i=0;i<3;i++)
        {
            for(j=0;j<3;j++)
            {
                body[h][i][j].draw();
                glTranslated(0,0,2);
            }
            glTranslated(0,2,-6);
        }
        glPopMatrix();
    }
    void Cubik::drawfdlayer(int h)
    {
        int i,j;
        glPushMatrix();
        glTranslated(-2,-2,(h-1)*2);

        for(i=0;i<3;i++)
        {
            for(j=0;j<3;j++)
            {
                body[i][j][h].draw();
                glTranslated(0,2,0);
            }
            glTranslated(2,-6,0);
        }
        glPopMatrix();
    }
    void Cubik::rotateup() // rotation of selected layer arount vertical axis (y)
    {
        int i,j,h=selecth;
        for(i=0;i<3;i++)
        for(j=0;j<3;j++)
            body[i][h][j].rotateup();

        Cubel tmp=body[2][h][2]; //corner elements
        body[2][h][2]=body[2][h][0];
        body[2][h][0]=body[0][h][0];
        body[0][h][0]=body[0][h][2];
        body[0][h][2]=tmp;

        tmp=body[2][h][1]; // side elements
        body[2][h][1]=body[1][h][0];
        body[1][h][0]=body[0][h][1];
        body[0][h][1]=body[1][h][2];
        body[1][h][2]=tmp;
    }
    void Cubik::rotatefd() // around fordward axis (z)
    {
        int i,j,h=selecth;
        for(i=0;i<3;i++)
        for(j=0;j<3;j++)
            body[i][j][h].rotatefd();

        Cubel tmp=body[2][2][h]; //corner elements
        body[2][2][h]=body[2][0][h];
        body[2][0][h]=body[0][0][h];
        body[0][0][h]=body[0][2][h];
        body[0][2][h]=tmp;

        tmp=body[2][1][h]; // side elements
        body[2][1][h]=body[1][0][h];
        body[1][0][h]=body[0][1][h];
        body[0][1][h]=body[1][2][h];
        body[1][2][h]=tmp;
    }
    void Cubik::rotatesd() // around side axis (x)
    {
        int i,j,h=selecth;
        for(i=0;i<3;i++)
        for(j=0;j<3;j++)
            body[h][i][j].rotatesd();

         Cubel tmp=body[h][2][2]; //corner elements
        body[h][2][2]=body[h][0][2];
        body[h][0][2]=body[h][0][0];
        body[h][0][0]=body[h][2][0];
        body[h][2][0]=tmp;

        tmp=body[h][1][2]; // side elements
        body[h][1][2]=body[h][0][1];
        body[h][0][1]=body[h][1][0];
        body[h][1][0]=body[h][2][1];
        body[h][2][1]=tmp;
    }
//////////////////////////////////////////////////////////////////////////////////////////
    Cubik::Cubik()
    {
        animation=0;
        selecth=1;
        selectax=UP;
        selectangle=0;
        reselectbody();
    }
    void Cubik::selax(axis a) // change selected axis
    {
        if(animation) return;
        selectax=a;
        reselectbody();
    }
    void Cubik::selh(int dif) // change selected layer
    {
        if(animation) return;
        selecth+=dif;
        if(selecth>2) selecth=0;
        if(selecth<0) selecth=2;
        reselectbody();
    }
    void Cubik::resetchanges() // assembles cubic into start position
    {
        for(int i=0;i<3;i++)
        for(int j=0;j<3;j++)
        for(int k=0;k<3;k++)
            body[i][j][k].reset();
    }
    void Cubik::draw() // draws cube layers along selected axis
    {
        glColor3f(0,0.1,0);
        int i;
        switch(selectax)
        {
            case UP:
                for(i=0;i<3;i++)
                {
                    if(i==selecth) // we can rotate selected layer
                    {
                        glPushMatrix();
                        glRotated(selectangle,0,1,0);
                        drawuplayer(i);
                        glPopMatrix();
                    }
                    else drawuplayer(i);
                }
            break;
            case SD:
                for(i=0;i<3;i++)
                {
                    if(i==selecth)
                    {
                        glPushMatrix();
                        glRotated(selectangle,1,0,0);
                        drawsdlayer(i);
                        glPopMatrix();
                    }
                    else drawsdlayer(i);
                }
            break;
            case FD:
                for(i=0;i<3;i++)
                {
                    if(i==selecth)
                    {
                        glPushMatrix();
                        glRotated(-selectangle,0,0,1);
                        drawfdlayer(i);
                        glPopMatrix();
                    }
                    else drawfdlayer(i);
                }
            break;
        }
    }
    void Cubik::drawscanning() // draws scanning of text
    {
        glPushMatrix();

        glTranslated(0,0,-2);
        drawfdlayer(0); //front

        glPushMatrix(); //top
        glTranslated(0,6,0);
        glRotated(90,1,0,0);
        drawuplayer(0);
        glPopMatrix();

        glPushMatrix(); //bottom
        glTranslated(0,-6,0);
        glRotated(-90,1,0,0);
        drawuplayer(2);
        glPopMatrix();

        glPushMatrix(); //left
        glTranslated(-6,0,0);
        glRotated(-90,0,1,0);
        drawsdlayer(0);
        glPopMatrix();

        glPushMatrix(); //right
        glTranslated(6,0,0);
        glRotated(90,0,1,0);
        drawsdlayer(2);
        glPopMatrix();

        glPushMatrix(); //back
        glTranslated(12,0,0);
        glRotated(180,0,1,0);
        drawfdlayer(2);
        glPopMatrix();

        glPopMatrix();
    }
    void Cubik::startanimation() // sets initial animation values
    {
        if(animation) return;
        animation=1;
        selectangle=0;
    }
    void Cubik::animationframe() // change state of cubic for next frame
    {
        if(!animation) return; // if animation is played;
        selectangle-=5;    // visual rotatation layer changing angle  /// Edit here to change speed of rotation
        if(selectangle<=-90) // if rotation is finished
        {
            animation=0;
            selectangle=0;
            switch(selectax)  // perform logical 90 degrees rotation
            {
                case UP: rotateup();break;
                case FD: rotatefd();break;
                case SD: rotatesd();break;
            }
        }
    }
void Cubik::randomize()
{
    int i,x;
    for(int i=0;i<100;i++)
    {
        x=random()%3;
        x-=1;
        selh(x);
        x=random()%3;
        switch(x)
        {
            case 0: rotateup();break;
            case 1: rotatefd();break;
            case 2: rotatesd();break;
        }
    }
    selh(0);
}
QString Cubik::tostring()
{
    QString res="";
    switch(selectax)
    {
        case UP:res="U"; break;
        case FD:res="F"; break;
        case SD:res="S"; break;
    }
    res+=QString::number(selecth);

    int i,j,k;
    for(i=0;i<3;i++)
    for(j=0;j<3;j++)
    for(k=0;k<3;k++)
    {
        res+=body[i][j][k].tostring();
    }
    return res;
}
void Cubik::fromstring(QString s)
{
    switch(s[0].toAscii())
    {
        case 'U':selectax=UP; break;
        case 'F':selectax=FD; break;
        case 'S':selectax=SD; break;
    }
    selecth=s[1].digitValue();
    int i,j,k;
    for(i=0;i<3;i++)
    for(j=0;j<3;j++)
    for(k=0;k<3;k++)
    {
        body[i][j][k].fromstring(s.mid(2+(i*9+j*3+k)*7,7));
    }
}
